/*
 * Software License Agreement (BSD License)
 *
 * Copyright (c) 2018 Oliver Mayer, Akademie der Bildenden Kuenste Nuernberg. 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*****************************************************************************  
 * Zeichnet primitive 2D-Formen, die Processing bereitstellt und ändert
 * deren Parameter abhängig von der Mausposition
 *****************************************************************************/

// normalisierte Mauskoordinate (zwischen 0 und 1)
float normalMouseX;
float normalMouseY;

void setup() {
  // Fenstergroesse
  size(700,100); 
}


void draw() {

  background(255);
  
  // normalisiere Mauskoordinaten
  normalMouseX = mouseX/(float)width;
  normalMouseY = mouseY/(float)height;

  // graue Linienfarbe für Trennlinien
  stroke(220);

  // vertikale Trennlinien
  line(100, 0, 100, height);
  line(200, 0, 200, height);
  line(300, 0, 300, height);
  line(400, 0, 400, height);
  line(500, 0, 500, height);
  line(600, 0, 600, height);
  
  // schwarze Linienfarbe für 2D Formen
  stroke(0);
  
  // Ändere die Linienbreite, damit der Punkt besser sichtbar ist
  strokeWeight(5);
  drawPoint();
  // setze die Linienbreite zurück
  strokeWeight(1);
  
  drawTriangle();
  drawRect();
  drawQuad();
  drawEllipse();
  drawArc();  
  drawLine();
}


// --- Funktionen zum Zeichnen der 2D Formen

void drawPoint() {
  point(normalMouseX*100, normalMouseY*100);
}

void drawTriangle() {
  fill(255, 255, 0);
  triangle(100, 100, 100 + normalMouseX*100, 0, 200, normalMouseY*100); 
}

void drawRect() {
  fill(255, 0, 0);
  rect(200, normalMouseY*100, normalMouseX*100, 100 - normalMouseY*100, 10); 
}

void drawQuad() {
  fill(0, 255, 255);
  quad(300, 50, 300 + normalMouseX*100, 0, 400, normalMouseY*100, 350, 100); 
}

void drawEllipse() {
  fill(255, 0, 255);
  ellipse(450, 50, normalMouseX*100, 100 - normalMouseY*100); 
}

void drawArc() {
  fill(0, 255, 0);
  arc(550, 50, 70, 70, radians(0), normalMouseX*radians(360.0)); 
}

void drawLine() {
  line(600, 100, 600 + normalMouseX*100, normalMouseY*100);
}
