/*
 * Software License Agreement (BSD License)
 *
 * Copyright (c) 2018 Oliver Mayer, Akademie der Bildenden Kuenste Nuernberg. 
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * - Redistributions of source code must retain the above copyright notice,
 *   this list of conditions and the following disclaimer.
 * - Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 */

/*****************************************************************************  
 * Sandbox for transformation of the coordinate system. Displays the 
 * stepwise transformation by repetitive drawing of rectangles.
 *****************************************************************************/


int n = 10; // number of rectangles

void setup() {
  size(600, 600, P3D);
  
  noFill();
  
  // draw rectangles by specifying its center, width and height
  rectMode(CENTER);
}

void draw() {
  
  background(0, 128, 128);
  
  // translate the coordinate system's center to the center of the displayed window
  translate(width/2, height/2);
  
  // in each iteration draw a rectangle, then transform the coordinate system a little more 
  for (int i = 0; i < n; i++) {
    
    // white stroke color for first rect, black otherwise
    if (i == 0)
      stroke(255);
    else
      stroke(0);

    rect(0, 0, width/2, height/2);
    
    scale(0.95, 1.06);
    //translate(0, 0, 25);
    //translate(0, 0, -100);
    //rotate(0.5*PI/n);
    //rotateY(0.5*PI/n);
    //shearX(0.2*PI/n);
    
    /*
    pushMatrix();
      translate(random(-width/4, width/4), random(-width/4, width/4), random(-500, 50));
      rotateX(random(0.5*PI));
      rotateY(random(0.5*PI));
      rotate(random(0.5*PI));
      rect(0, 0, width/2, height/2);
    popMatrix();  
    */
   
  }
  
  delay(500);
}
